//+------------------------------------------------------------------+
//|                                                            JAson |
//|                       programming & development - Alexey Sergeev |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006-2015  Alexey Sergeev"
#property link      "profy.mql@gmail.com"
#property version "1.00"
#property strict
//---
#include <JAson.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnStart()
  {
   string in,out;
   CJAVal js(NULL,jtUNDEF); bool b;
   
//---
   Print("JASon Example Deserialization:");
//---
   in="{\"a\":[1,2]}"; out="";
   b=js.Deserialize(in);
   js.Serialize(out);
   Print(in+" -> "+out);
//---
   in="{\"a\":[{\"b\":1},{\"c\":2}]}"; out="";
   b=js.Deserialize(in);
   js.Serialize(out);
   Print(in+" -> "+out);
//---
   in="{\"res\":{\"tas\":[{\"mas1\":[{\"ma1\":{\"t\":1}}]}]}"; out="";
   b=js.Deserialize(in); js.Serialize(out);
   Print(in+" -> "+out);
//---
   string ma1="{\"ma1\":{\"t1\":1}}";
   string ma2="{\"ma2\":{\"t2\":1}}";
   string mas=StringFormat("{\"mas1\":[%s,%s]}", ma1, ma2);
   in=StringFormat("{\"tas\":[%s,%s]}",mas,mas); out="";
   b=js.Deserialize(in); js.Serialize(out);
   Print(in+" -> "+out);
//---

   Print("JASon Example Serialization:");
   js.Clear();
   out=""; js.Serialize(out);
//---
   js["Test"]=1.4;
   out=""; js.Serialize(out); Print(out);
//---
   CJAVal num(1);
   js["Best"].Add(num);
   js["Best"].Add(num);
   
   string a[] = {"test", "add", "to array"};
   js["a"].Add(a[0]);
   js["a"].Add(a[1]);
   js["a"].Add(a[2]);

   out=""; js.Serialize(out); Print(out);
//---
   CJAVal jb;
   jb["JS"].Set(js);
   out=""; jb.Serialize(out,false);
   Print(out);
//---
   jb["Arr"].Add(js);
   out=""; jb.Serialize(out,false);
   Print(out);
//---
   jb["Arr"].Add(js);
   out=""; jb.Serialize(out,false);
   Print(out);
//---
   b=jb.Deserialize(out);
   Print("deserialize=",b);
  }
//+------------------------------------------------------------------+
